/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
#ifndef TOPPERS_CQ_STARM_H
#define TOPPERS_CQ_STARM_H

#include <sil.h>

/*
 * CORTEX-M3 CPÜˑ̃CN[h
 */
#include "arm_m_iccarm/arm_m.h"

/*
 *  VXeNbN̒`
 */
#define BUS_CLOCK		(60000000)
#define SYS_CLOCK		(120000000)
#define FLASH_CLOCK		(20000000)
#define DDR_CLOCK		(150000000)

/*
 *  ݔԍ̍ől
 */
#define TMAX_INTNO   (16 + 105)

/*
 *  ݗDx̃rbg
 */
#define TBITW_IPRI     4

/*
 *  ݗDxrbg̃TuDx̃rbg
 */
#define TBITW_SUBIPRI  0

/*
 *  ݃xN^ԍ`
 */
#define IRQ_VECTOR_USART2		(16 + 49)


/* ytFWX^` */
#define PERIPH_REG_BASE			(0x40000000UL)
#define SRAM_BASE				(0x1FFF0000UL)


#define SIM_BASE				(PERIPH_REG_BASE + 0x47000)
#define PORTA_BASE				(PERIPH_REG_BASE + 0x49000)
#define PORTE_BASE				(PERIPH_REG_BASE + 0x4D000)
#define WDOG_BASE				(PERIPH_REG_BASE + 0x52000)
#define MCG_BASE				(PERIPH_REG_BASE + 0x64000)
#define UART2_BASE				(PERIPH_REG_BASE + 0x6C000)
#define PMC_BASE				(PERIPH_REG_BASE + 0x7D000)
#define GPIOA_BASE				(PERIPH_REG_BASE + 0xFF000)


/* System Control space */
#define SCS_BASE				(0xE000E000)
#define SYSTM_BASE				(SCS_BASE + 0x0010)
#define NVIC_BASE				(SCS_BASE + 0x0100)
#define SYSCB_BASE				(SCS_BASE + 0x0D00)

/* WDOG */
#define WDOG_STCTRTLH   (WDOG_BASE + 0x00)
#define WDOG_UNLOCK     (WDOG_BASE + 0x0E)

/* SIM */
#define SIM_SCGC4       (SIM_BASE + 0x1034)
#define SIM_SCGC5       (SIM_BASE + 0x1038)
#define SIM_CLKDIV1     (SIM_BASE + 0x1044)

/* PMC */
#define PMC_REGSC       (PMC_BASE + 0x02)

/* PORT_A */
#define PORTA_PCR10     (PORTA_BASE + 0x28)
#define PORTA_PCR11     (PORTA_BASE + 0x2C)
#define PORTA_PCR28     (PORTA_BASE + 0x70)
#define PORTA_PCR29     (PORTA_BASE + 0x74)

/* PORT_E */
#define PORTE_PCR16     (PORTE_BASE + 0x40)
#define PORTE_PCR17     (PORTE_BASE + 0x44)

/* GPIO_A */
#define GPIOA_PSOR      (GPIOA_BASE + 0x04)
#define GPIOA_PCOR      (GPIOA_BASE + 0x08)
#define GPIOA_PTOR      (GPIOA_BASE + 0x0C)
#define GPIOA_PDDR      (GPIOA_BASE + 0x14)

/* MCG */
#define MCG_C1          (MCG_BASE + 0x00)
#define MCG_C2          (MCG_BASE + 0x01)
#define MCG_C5          (MCG_BASE + 0x04)
#define MCG_C6          (MCG_BASE + 0x05)
#define MCG_S           (MCG_BASE + 0x06)
#define MCG_C11         (MCG_BASE + 0x10)
#define MCG_C12         (MCG_BASE + 0x11)
#define MCG_S2          (MCG_BASE + 0x12)

/* UART2 */
#define UART2_BDH       (UART2_BASE + 0x00)
#define UART2_BDL       (UART2_BASE + 0x01)
#define UART2_C1        (UART2_BASE  +0x02)
#define UART2_C2        (UART2_BASE + 0x03)
#define UART2_S1        (UART2_BASE + 0x04)
#define UART2_D         (UART2_BASE + 0x07)
#define UART2_C4        (UART2_BASE + 0x0A)

/* SCB */
#define SCB_VTOR        (SYSCB_BASE + 0x08)
#define SCB_AIRCR       (SYSCB_BASE + 0x0C)
#define SCB_SHPR3       (SYSCB_BASE + 0x20)

/* NVIC */
#define NVIC_ENAVLE_REG(ch)		(NVIC_BASE + ((ch) >> 5))
#define NVIC_DISABLE_REG(ch)	(NVIC_BASE + 0x80 + ((ch) >> 5))
#define NVIC_SET_PEND_REG(ch)	(NVIC_BASE + 0x100 + ((ch) >> 5))
#define NVIC_CLEAR_PEND_REG(ch)	(NVIC_BASE + 0x180 + ((ch) >> 5))
#define NVIC_ACTIVE_REG(ch)		(NVIC_BASE + 0x200 + ((ch) >> 5))
#define NVIC_PRIO_REG(ch)		(NVIC_BASE + 0x300 + ((ch) >> 2))
#define NVIC_STIR       		(NVIC_BASE+0xE00)     


#ifndef TOPPERS_MACRO_ONLY

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_CQ_STARM_H */
