/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 * ^[QbgˑW[iFS K70pj
 */
#include "kernel_impl.h"
#include <sil.h>
#include "fs_k70f120m.h"
#include "target_serial.h"
#include "target_syssvc.h"

STK_T _target_istk[DEFAULT_ISTKSZ];


/*
 * ^[Qbgˑ@
 */
void target_initialize(void)
{
	/*
	 *  vZbTNbN̏
	 */
	if ((sil_reb_mem( (void*)PMC_REGSC ) & 0x8) == 0)
		sil_orb( (void*)PMC_REGSC, 0x8 );

	sil_wrw_mem( (void*)SIM_CLKDIV1, 0x01250000);

	sil_wrb_mem( (void*)MCG_C2, ((sil_reb_mem( (void*)MCG_C2 ) & ~0x3C) | 0x10) );
	sil_wrb_mem( (void*)MCG_C1, ((sil_reb_mem( (void*)MCG_C1 ) & ~0xFC) | 0x80 | 0x28) );
	while ( ( sil_reb_mem( (void*)MCG_S ) & 0x10 ) == 0 ) ;
	while ((( sil_reb_mem( (void*)MCG_S ) & 0x0C ) >> 2 ) != 0x2 ) ;

	sil_orb( (void*)MCG_C6, 0x20 );
	sil_andb( (void*)MCG_C5, ~0x80 );
	sil_andb( (void*)MCG_C11, ~0x10 );

	sil_wrb_mem( (void*)MCG_C5, ((sil_reb_mem( (void*)MCG_C5 ) & ~0x07) | (0x05 - 1)) );
	sil_wrb_mem( (void*)MCG_C6, ((sil_reb_mem( (void*)MCG_C6 ) & ~0x1F) | (0x40 | (0x18 - 16))) );
	while ( ( sil_reb_mem( (void*)MCG_S ) & 0x20 ) == 0 ) ;
	while ( ( sil_reb_mem( (void*)MCG_S ) & 0x40 ) == 0 ) ;

	sil_andb( (void*)MCG_C1, ~0xC0 );
	while ( (( sil_reb_mem( (void*)MCG_S ) & 0x0C ) >> 2) != 0x03 ) ;

	sil_andb( (void*)MCG_C11, ~0x80 );
	sil_wrb_mem( (void*)MCG_C11, ((sil_reb_mem( (void*)MCG_C11 ) & ~0x07) | (0x05 - 1)) );
	sil_wrb_mem( (void*)MCG_C12, ((sil_reb_mem( (void*)MCG_C12 ) & ~0x1F) | (0x1E - 16)) );

	sil_orb( (void*)MCG_C11, 0x40 );
	while ( ( sil_reb_mem( (void*)MCG_S2 ) & 0x40 ) == 0 ) ;

	/*
	 *  vZbTˑ̏
	 */
	core_initialize();

	/* LED|[g */
	sil_orw( (void*)SIM_SCGC5, 0x00047F80 );
	sil_wrw_mem( (void*)PORTA_PCR10, 0x00000100 );
	sil_wrw_mem( (void*)PORTA_PCR11, 0x00000100 );
	sil_wrw_mem( (void*)PORTA_PCR28, 0x00000100 );
	sil_wrw_mem( (void*)PORTA_PCR29, 0x00000100 );
	sil_orw( (void*)GPIOA_PDDR, 0x30000C00 );

	/*
	 *  I/O|[g̏
	 */
	/* USART2*/
	sil_wrw_mem( (void*)PORTE_PCR16, 0x00000300 );
	sil_wrw_mem( (void*)PORTE_PCR17, 0x00000300 );
	/* USART2 clock enable */
	sil_orw( (void*)SIM_SCGC4, 0x00001000 );

	/*
	 *  o[i[o͗p̃VA
	 */
	target_uart_init(SIO_PORTID);
}

/*
 * ^[Qbgˑ@I
 */
void target_exit(void)
{
	/* vZbTˑ̏I */
	core_terminate();

	/*
	 *  Jˑ̏I
	 */
	while(1);
}

/*
 * VXeO̒჌xo͂̂߂̕o
 */
void target_fput_log(char_t c)
{
	if (c == '\n') {
		sio_pol_snd_chr('\r', SIO_PORTID);
	}
	sio_pol_snd_chr(c, SIO_PORTID);
}
